// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: emulator_controller.proto

package com.android.emulator.control;

public interface KeyboardEventOrBuilder extends
    // @@protoc_insertion_point(interface_extends:android.emulation.control.KeyboardEvent)
    com.google.protobuf.MessageOrBuilder {

  /**
   * <pre>
   * Type of keycode contained in the keyCode field.
   * </pre>
   *
   * <code>.android.emulation.control.KeyboardEvent.KeyCodeType codeType = 1;</code>
   * @return The enum numeric value on the wire for codeType.
   */
  int getCodeTypeValue();
  /**
   * <pre>
   * Type of keycode contained in the keyCode field.
   * </pre>
   *
   * <code>.android.emulation.control.KeyboardEvent.KeyCodeType codeType = 1;</code>
   * @return The codeType.
   */
  com.android.emulator.control.KeyboardEvent.KeyCodeType getCodeType();

  /**
   * <pre>
   * The type of keyboard event that should be sent to the emulator
   * </pre>
   *
   * <code>.android.emulation.control.KeyboardEvent.KeyEventType eventType = 2;</code>
   * @return The enum numeric value on the wire for eventType.
   */
  int getEventTypeValue();
  /**
   * <pre>
   * The type of keyboard event that should be sent to the emulator
   * </pre>
   *
   * <code>.android.emulation.control.KeyboardEvent.KeyEventType eventType = 2;</code>
   * @return The eventType.
   */
  com.android.emulator.control.KeyboardEvent.KeyEventType getEventType();

  /**
   * <pre>
   * This property represents a physical key on the keyboard (as opposed
   * to the character generated by pressing the key). In other words, this
   * property is a value which isn't altered by keyboard layout or the
   * state of the modifier keys. This value will be interpreted by the
   * emulator depending on the KeyCodeType. The incoming key code will be
   * translated to an evdev code type and send to the emulator.
   * The values in key and text will be ignored.
   * </pre>
   *
   * <code>int32 keyCode = 3;</code>
   * @return The keyCode.
   */
  int getKeyCode();

  /**
   * <pre>
   * The value of the key pressed by the user, taking into consideration
   * the state of modifier keys such as Shift as well as the keyboard
   * locale and layout. This follows the w3c standard used in browsers.
   * You can find an accurate description of valid values
   * [here](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values)
   *
   * Note that some keys can result in multiple evdev events that are
   * delivered to the emulator. for example the Key "A" will result in a
   * sequence:
   * ["Shift", "a"] -&gt; [0x2a, 0x1e] whereas "a" results in ["a"] -&gt; [0x1e].
   *
   * Not all documented keys are understood by android, and only printable
   * ASCII [32-127) characters are properly translated.
   *
   * Keep in mind that there are a set of key values that result in android
   * specific behavior
   * [see](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values#Phone_keys):
   *
   * - "AppSwitch": Behaves as the "Overview" button in android.
   * - "GoBack": The Back button.
   * - "GoHome": The Home button, which takes the user to the phone's main
   *             screen (usually an application launcher).
   * - "Power":  The Power button.
   * </pre>
   *
   * <code>string key = 4;</code>
   * @return The key.
   */
  java.lang.String getKey();
  /**
   * <pre>
   * The value of the key pressed by the user, taking into consideration
   * the state of modifier keys such as Shift as well as the keyboard
   * locale and layout. This follows the w3c standard used in browsers.
   * You can find an accurate description of valid values
   * [here](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values)
   *
   * Note that some keys can result in multiple evdev events that are
   * delivered to the emulator. for example the Key "A" will result in a
   * sequence:
   * ["Shift", "a"] -&gt; [0x2a, 0x1e] whereas "a" results in ["a"] -&gt; [0x1e].
   *
   * Not all documented keys are understood by android, and only printable
   * ASCII [32-127) characters are properly translated.
   *
   * Keep in mind that there are a set of key values that result in android
   * specific behavior
   * [see](https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/key/Key_Values#Phone_keys):
   *
   * - "AppSwitch": Behaves as the "Overview" button in android.
   * - "GoBack": The Back button.
   * - "GoHome": The Home button, which takes the user to the phone's main
   *             screen (usually an application launcher).
   * - "Power":  The Power button.
   * </pre>
   *
   * <code>string key = 4;</code>
   * @return The bytes for key.
   */
  com.google.protobuf.ByteString
      getKeyBytes();

  /**
   * <pre>
   * Series of utf8 encoded characters to send to the emulator. An attempt
   * will be made to translate every character will an EvDev event type and
   * send to the emulator as a keypress event. The values in keyCode,
   * eventType, codeType and key will be ignored.
   *
   * Note that most printable ASCII characters (range [32-127) can be send
   * individually with the "key" param. Do not expect arbitrary UTF symbols to
   * arrive in the emulator (most will be ignored).
   *
   * Note that it is possible to overrun the keyboard buffer by slamming this
   * endpoint with large quantities of text (&gt;1kb). The clipboard api is
   * better suited for transferring large quantities of text.
   * </pre>
   *
   * <code>string text = 5;</code>
   * @return The text.
   */
  java.lang.String getText();
  /**
   * <pre>
   * Series of utf8 encoded characters to send to the emulator. An attempt
   * will be made to translate every character will an EvDev event type and
   * send to the emulator as a keypress event. The values in keyCode,
   * eventType, codeType and key will be ignored.
   *
   * Note that most printable ASCII characters (range [32-127) can be send
   * individually with the "key" param. Do not expect arbitrary UTF symbols to
   * arrive in the emulator (most will be ignored).
   *
   * Note that it is possible to overrun the keyboard buffer by slamming this
   * endpoint with large quantities of text (&gt;1kb). The clipboard api is
   * better suited for transferring large quantities of text.
   * </pre>
   *
   * <code>string text = 5;</code>
   * @return The bytes for text.
   */
  com.google.protobuf.ByteString
      getTextBytes();
}
